# Genetic Algorithms

A custom Python package implementing a Genetic Algorithm (GA) with support for Pygame visualization. This package allows you to run genetic algorithms for optimization problems and visualize the evolution of the population over generations.

## Features

- **Genetic Algorithm Implementation**: Easily customizable with different mutation rates, crossover rates, and fitness functions.
- **Pygame Visualization**: Visualize the evolution of the population over time using a graphical interface.
- **Elitism**: Support for elitism to carry the best individuals to the next generation.
- **Early Stopping**: Stop the algorithm early if the population's fitness stagnates for a certain number of generations.

## Installation

### Option 1: Install Locally

You can install the package locally by cloning the repository and running:

```bash
pip install .
```